/* ***************************************************************/
/* $(RTDS_HOME)/share/ccg/ose/bricks/RTDS_Startup_begin.c begins */
/* PragmaDev RTDS OSE Delta integration                          */
#ifdef RTDS_BACK_TRACE_MAX_EVENT_NUM
#include "RTDS_BackTrace.h"
#endif
#if defined(RTDS_SIMULATOR) || defined(RTDS_MSC_TRACE) || defined(RTDS_FORMAT_TRACE) || defined(RTDS_SOCKET_IP_ADDRESS)
#include "RTDS_Trace.h"
#endif
/* Pointers to global list of information on processes and semaphores */
RTDS_GlobalProcessInfo		*RTDS_globalProcessInfo=NULL;
RTDS_GlobalSemaphoreInfo	*RTDS_globalSemaphoreInfo=NULL;


RTDS_COVERAGE_DECL
RTDS_CRITICAL_SECTION_DECL


void RTDS_Start(void)
{

RTDS_GlobalProcessInfo *RTDS_currentContext, *RTDS_processInfo;

RTDS_COVERAGE_INIT;

#if defined(RTDS_SIMULATOR) || defined(RTDS_MSC_TRACE) || defined(RTDS_FORMAT_TRACE)
/* Set up the message unique id pool */
RTDS_globalMessageUniqueIdPool = (unsigned char *)RTDS_MALLOC(RTDS_MESSAGE_UNIQUE_ID_POOL_SIZE);
	{
	int RTDS_i;
	unsigned char *RTDS_index;

	RTDS_index = RTDS_globalMessageUniqueIdPool;
	for(RTDS_i=0;RTDS_i<RTDS_MESSAGE_UNIQUE_ID_POOL_SIZE;RTDS_i++)
		{
		*RTDS_index=0x00;
		RTDS_index++;
		}
	}
#endif

#if defined(RTDS_BACK_TRACE_MAX_EVENT_NUM) && defined(RTDS_SIMULATOR)
/* Initialize circular buffer to trace in RAM */
RTDS_TraceInit();
#endif

/* Set up the process context needed to create tasks */
RTDS_currentContext = (RTDS_GlobalProcessInfo *)RTDS_MALLOC(sizeof(RTDS_GlobalProcessInfo));
if ( RTDS_currentContext == NULL )
	RTDS_SYSTEM_ERROR(RTDS_ERROR_STARTUP_CONTEXT_MALLOC);
RTDS_currentContext->processNumber = 0;
RTDS_currentContext->sdlState = 0;
RTDS_currentContext->next = NULL;
RTDS_currentContext->parentQueueId	= (RTDS_QueueId)NULL;
RTDS_currentContext->offspringQueueId = (RTDS_QueueId)NULL;
RTDS_currentContext->currentMessage = NULL;
RTDS_currentContext->timerList = NULL;
RTDS_currentContext->myQueueId	= (RTDS_QueueId)NULL;

RTDS_CRITICAL_SECTION_INIT;
/* $(RTDS_HOME)/share/ccg/ose/bricks/RTDS_Startup_begin.c ends */
/* *************************************************************** */
