#ifndef _RTDS_COUNTING_SEMAPHORE_PROCESS_H_
#define _RTDS_COUNTING_SEMAPHORE_PROCESS_H_

#include "RTDS_SemaphoreProcess.h"

/*
** PROCESS RTDS_CountingSemaphoreProcess:
** --------------------------------------
*/

class RTDS_CountingSemaphoreProcess : public RTDS_SemaphoreProcess
  {
  public:
    int available_slots;
    

    // Constructor:
    RTDS_CountingSemaphoreProcess(RTDS_Scheduler * parentScheduler);
    
    // Checks if the semaphore is available
    virtual long isAvailable() { return this->available_slots > 0; };

    // Entry point for all transitions:
    short RTDS_executeTransition(RTDS_MessageHeader * currentMessage);

    // Entry point for transitions for continuous signals:
    short RTDS_continuousSignals(int * lowestPriority);
  };

#else

class RTDS_CountingSemaphoreProcess;

#endif
